//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TFormComPort.h"
#include "TFormMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "te_controls"
#pragma link "TntStdCtrls"
#pragma resource "*.dfm"
TFormComPort *FormComPort;
//---------------------------------------------------------------------------
__fastcall TFormComPort::TFormComPort(TComponent* Owner)
        : TForm(Owner)
{
        if(FormMain->ComKind == 0)
        {
            BPortClose->Caption = FormMain->LangFile.FormComportButton1;
            BPortCon->Caption = FormMain->LangFile.FormComportButton2;
        }
        else
        {
            BPortClose->Caption = FormMain->LangFile.FormComportButton4;
            BPortCon->Caption = FormMain->LangFile.FormComportButton5;
        }
}
//---------------------------------------------------------------------------


void __fastcall TFormComPort::FormCreate(TObject *Sender)
{
        SearchComPort();
        ComBox1->Text = FormMain->PortUse1;
        BaudBox1->ItemIndex = FormMain->BaudRateUse1;
        Edit2->Text = FormMain->IPAddress;
        Edit3->Text = StrToIntDef(FormMain->IPPort, 5000);
        Edit4->Text = FormMain->UDPIPAddress;
        Edit5->Text = StrToIntDef(FormMain->SRCPort, 5109);
        if(FormMain->ComKind == 1)
            rbLAN->Checked = true;
        else if(FormMain->ComKind == 2)
            rbUDP->Checked = true;
        else
            rbSerial->Checked = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormComPort::rbComKind(TObject *Sender)
{
        if(BPortClose->Enabled)
            BPortClose->Click();
        if(rbLAN->Checked)
            FormMain->ComKind = 1;
        else if(rbUDP->Checked)
            FormMain->ComKind = 2;
        else
            FormMain->ComKind = 0;
        Label1->Enabled = rbSerial->Checked;
        ComBox1->Enabled = rbSerial->Checked;
        TeLabel1->Enabled = rbSerial->Checked;
        BaudBox1->Enabled = rbSerial->Checked;
        BSystem->Enabled = rbSerial->Checked;
        TntLabel4->Enabled = rbLAN->Checked;
        Edit2->Enabled = rbLAN->Checked;
        Label3->Enabled = rbLAN->Checked;
        Edit3->Enabled = rbLAN->Checked;
        TntLabel1->Enabled = rbUDP->Checked;
        Edit4->Enabled = rbUDP->Checked;
        //TntLabel2->Enabled = rbUDP->Checked;
        //Edit5->Enabled = rbUDP->Checked;
        if(FormMain->ComKind == 0)
        {
            BPortClose->Caption = FormMain->LangFile.FormComportButton1;
            BPortCon->Caption = FormMain->LangFile.FormComportButton2;
        }
        else
        {
            BPortClose->Caption = FormMain->LangFile.FormComportButton4;
            BPortCon->Caption = FormMain->LangFile.FormComportButton5;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormComPort::SearchComPort()
{
        // ø Ʈ ã Լ
        TRegistry *reg = new TRegistry;
        TStringList *UnKey = new TStringList;
        ComBox1->Items->Clear();
        reg->RootKey = HKEY_LOCAL_MACHINE;
        if(reg->OpenKey("HARDWARE\\DEVICEMAP\\SERIALCOMM",false))
        {
            reg->GetValueNames(UnKey);
            for(int j = 0; j < UnKey->Count; j++)
            {
                if(reg->ValueExists( UnKey->Strings[j]))
                    ComBox1->Items->Add(reg->ReadString(UnKey->Strings[j]));
            }
            ComBox1->Sorted = true;
            reg->CloseKey();
        }
        if(UnKey->Count <= 0)
        {
            for(int j = 1; j <= 10; j++)
                ComBox1->Items->Add("COM" + IntToStr(j));
            ComBox1->Sorted = true;
        }
        delete reg;
        delete UnKey;
        ComBox1->Sorted = true;
}
//---------------------------------------------------------------------------

void __fastcall TFormComPort::BSystemClick(TObject *Sender)
{
        //  ġ   ư
        HINSTANCE Ret;
        char szSystemPath[MAX_PATH];
        GetSystemDirectory(szSystemPath, MAX_PATH);
        AnsiString Path = AnsiString(szSystemPath);
        Ret = ShellExecute(0, "open", AnsiString(Path + "\\devmgmt.msc").c_str(), Path.c_str(), Path.c_str(), SW_SHOWNORMAL);
        if((int)Ret <= 32)
        {
            Ret = ShellExecute(0, "open", AnsiString(Path + "\\devmgmt.msc").c_str(), Path.c_str(), Path.c_str(), SW_SHOWNORMAL);
            if((int)Ret <= 32)
            {
                AnsiString asMessage = "devmgmt.msc File Not Open.";
                FormMain->Message("\r\n" + asMessage + "\r\n", FormMain->LangFile.MessageButton04, "", "", asMessage.Length() - 2, 3, 1, clRed);
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormComPort::BPortCloseClick(TObject *Sender)
{
        try{
            if(FormMain->ComClose(FormMain->ComKind))
            {
                BPortClose->Enabled = false;
                BPortCon->Enabled = true;
            }
        }catch(...){
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormComPort::BPortConClick(TObject *Sender)
{
        if(rbLAN->Checked)
            FormMain->ComKind = 1;
        else if(rbUDP->Checked)
            FormMain->ComKind = 2;
        else
            FormMain->ComKind = 0;
        FormMain->PortUse1 = AnsiString(ComBox1->Text).TrimRight();
        FormMain->BaudRateUse1 = (eBaudRate)BaudBox1->ItemIndex;
        FormMain->IPAddress = AnsiString(Edit2->Text).TrimRight();
        FormMain->IPPort = StrToIntDef(AnsiString(Edit3->Text).TrimRight(), 5000);
        FormMain->UDPIPAddress = AnsiString(Edit4->Text).TrimRight();
        FormMain->SRCPort = StrToIntDef(AnsiString(Edit5->Text).TrimRight(), 5000);
        FormMain->bStopSend = false;
        if(FormMain->ComPortSet(FormMain->ComKind, FormMain->PortUse1, FormMain->BaudRateUse1, Disable, Disable, FormMain->IPAddress, FormMain->IPPort, true))
        {
            BPortClose->Enabled = true;
            BPortCon->Enabled = false;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFormComPort::ComBox1ListBoxClick(TObject *Sender)
{
        ComBox1->Text = ComBox1->Items->Strings[ComBox1->ItemIndex];        
}
//---------------------------------------------------------------------------

void __fastcall TFormComPort::ComBox1DropDown(TObject *Sender)
{
        SearchComPort();        
}
//---------------------------------------------------------------------------

